/*
 * VL1: a Casio VL-Tone emulator
 * Copyright (C) 2006 PolyValens
 * Copyright (C) 2019 Jean Pierre Cimalando
 *
 * SPDX-License-Identifier: CC0-1.0 or MIT
 */

#include "DemoSong.h"
#include "Sequencer.h"

extern const tSequencerEvent gDemoSongData[kDemoSongLength] =
{
	{          0, { kControlChange, kRhythm, kSwing, 0 }, 0 },
	{          0, { kControlChange, kRhythmOn, 1, 0 }, 0 },

	{          0, { kProgramChange, kProgramPiano, 0, 0 }, 0 },
	{          0, { kNoteOn,  60, 127, 0 }, 0 },
	{   1*kWhole, { kNoteOff, 60, 127, 0 }, 0 },
	{   1*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{   2*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{   2*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{   3*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{   3*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{   4*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{   4*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{   5*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{   5*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{   13*kHalf, { kNoteOff, 69, 127, 0 }, 0 },
	{   13*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{   7*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{   7*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{   8*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{   8*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{   9*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{   9*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  10*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  10*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  11*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  11*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  12*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  12*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  13*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  13*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  16*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{  16*kWhole, { kNoteOn,  60, 127, 0 }, 0 },
	{  17*kWhole, { kNoteOff, 60, 127, 0 }, 0 },
	{  17*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  18*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{  18*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  19*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{  19*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  20*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  20*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  21*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  21*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{   45*kHalf, { kNoteOff, 69, 127, 0 }, 0 },
	{   45*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{  23*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{  23*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  24*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{  24*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{  25*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  25*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  26*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  26*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  27*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  27*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  28*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  28*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  29*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  29*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  32*kWhole, { kNoteOff, 65, 127, 0 }, 0 },

	{  32*kWhole, { kProgramChange, kProgramFantasy, 0, 0 }, 0 },
	{  32*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{   65*kHalf, { kNoteOff, 72, 127, 0 }, 0 },
	{   65*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{  33*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{  33*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  34*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  34*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  35*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  35*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  36*kWhole, { kNoteOff, 69, 127, 0 }, 0 },

	{  36*kWhole, { kProgramChange, kProgramViolin, 0, 0 }, 0 },
	{  36*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{   73*kHalf, { kNoteOff, 70, 127, 0 }, 0 },
	{   73*kHalf, { kNoteOn,  69, 127, 0 }, 0 },
	{  37*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  37*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  38*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  38*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  39*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  39*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  40*kWhole, { kNoteOff, 67, 127, 0 }, 0 },

	{  40*kWhole, { kProgramChange, kProgramFantasy, 0, 0 }, 0 },
	{  40*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{   81*kHalf, { kNoteOff, 72, 127, 0 }, 0 },
	{   81*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{  41*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{  41*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  42*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  42*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  43*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  43*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  44*kWhole, { kNoteOff, 69, 127, 0 }, 0 },

	{  44*kWhole, { kProgramChange, kProgramViolin, 0, 0 }, 0 },
	{  44*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{   89*kHalf, { kNoteOff, 70, 127, 0 }, 0 },
	{   89*kHalf, { kNoteOn,  69, 127, 0 }, 0 },
	{  45*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  45*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  46*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  46*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  47*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  47*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  48*kWhole, { kNoteOff, 67, 127, 0 }, 0 },

	{  48*kWhole, { kProgramChange, kProgramPiano, 0, 0 }, 0 },
	{  48*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  49*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{  49*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  50*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  50*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  51*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{  51*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  52*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  52*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  53*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  53*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  56*kWhole, { kNoteOff, 65, 127, 0 }, 0 },

///////////////
	{  56*kWhole, { kControlChange, kRhythm, kRock1, 0 }, 0 },
	{  56*kWhole, { kControlChange, kRhythmOn, 6, 0 }, 0 },
	{  56*kWhole, { kProgramChange, kProgramFantasy, 0, 0 }, 0 },

	{  56*kWhole, { kNoteOn,  60, 127, 0 }, 0 },
	{  57*kWhole, { kNoteOff, 60, 127, 0 }, 0 },
	{  57*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  58*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{  58*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  59*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{  59*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  60*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  60*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  61*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  61*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  125*kHalf, { kNoteOff, 69, 127, 0 }, 0 },
	{  125*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{  63*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{  63*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  64*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{  64*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{  65*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{  65*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  66*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  66*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  67*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  67*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  68*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  68*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  69*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  69*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  72*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{  72*kWhole, { kNoteOn,  60, 127, 0 }, 0 },
	{  73*kWhole, { kNoteOff, 60, 127, 0 }, 0 },
	{  73*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  74*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{  74*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  75*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{  75*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  76*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  76*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  77*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  77*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  157*kHalf, { kNoteOff, 69, 127, 0 }, 0 },
	{  157*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{  79*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{  79*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  80*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{  80*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{  81*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  81*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  82*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  82*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  83*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  83*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  84*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  84*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  85*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  85*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{  88*kWhole, { kNoteOff, 65, 127, 0 }, 0 },

	{  88*kWhole, { kProgramChange, kProgramViolin, 0, 0 }, 0 },
	{  88*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  177*kHalf, { kNoteOff, 72, 127, 0 }, 0 },
	{  177*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{  89*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{  89*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  90*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  90*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  91*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  91*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  92*kWhole, { kNoteOff, 69, 127, 0 }, 0 },

	{  92*kWhole, { kProgramChange, kProgramFlute, 0, 0 }, 0 },
	{  92*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{  185*kHalf, { kNoteOff, 70, 127, 0 }, 0 },
	{  185*kHalf, { kNoteOn,  69, 127, 0 }, 0 },
	{  93*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  93*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  94*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  94*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  95*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{  95*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{  96*kWhole, { kNoteOff, 67, 127, 0 }, 0 },

	{  96*kWhole, { kProgramChange, kProgramViolin, 0, 0 }, 0 },
	{  96*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  193*kHalf, { kNoteOff, 72, 127, 0 }, 0 },
	{  193*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{  97*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{  97*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  98*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  98*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  99*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{  99*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 100*kWhole, { kNoteOff, 69, 127, 0 }, 0 },

	{ 100*kWhole, { kProgramChange, kProgramFlute, 0, 0 }, 0 },
	{ 100*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{  201*kHalf, { kNoteOff, 70, 127, 0 }, 0 },
	{  201*kHalf, { kNoteOn,  69, 127, 0 }, 0 },
	{ 101*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 101*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 102*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 102*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 103*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 103*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 104*kWhole, { kNoteOff, 67, 127, 0 }, 0 },

	{ 104*kWhole, { kProgramChange, kProgramFantasy, 0, 0 }, 0 },
	{ 104*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{ 105*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{ 105*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 106*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 106*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 107*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 107*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 108*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 108*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 109*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 109*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 112*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
///////////////
	{ 112*kWhole, { kControlChange, kRhythm, kRock2, 0 }, 0 },
	{ 112*kWhole, { kControlChange, kRhythmOn, 7, 0 }, 0 },
	{ 112*kWhole, { kProgramChange, kProgramViolin, 0, 0 }, 0 },

	{ 112*kWhole, { kNoteOn,  60, 127, 0 }, 0 },
	{ 113*kWhole, { kNoteOff, 60, 127, 0 }, 0 },
	{ 113*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 114*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 114*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 115*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 115*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 116*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 116*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 117*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 117*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  237*kHalf, { kNoteOff, 69, 127, 0 }, 0 },
	{  237*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{ 119*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 119*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{ 120*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{ 120*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{ 121*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 121*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 122*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 122*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 123*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 123*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 124*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 124*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 125*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 125*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 128*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 128*kWhole, { kNoteOn,  60, 127, 0 }, 0 },
	{ 129*kWhole, { kNoteOff, 60, 127, 0 }, 0 },
	{ 129*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 130*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 130*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 131*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 131*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 132*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 132*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 133*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 133*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  269*kHalf, { kNoteOff, 69, 127, 0 }, 0 },
	{  269*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{ 135*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 135*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{ 136*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{ 136*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{ 137*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 137*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 138*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 138*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 139*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 139*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 140*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 140*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 141*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 141*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 144*kWhole, { kNoteOff, 65, 127, 0 }, 0 },

	{ 144*kWhole, { kProgramChange, kProgramFlute, 0, 0 }, 0 },
	{ 144*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  289*kHalf, { kNoteOff, 72, 127, 0 }, 0 },
	{  289*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{ 145*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 145*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 146*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 146*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 147*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 147*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 148*kWhole, { kNoteOff, 69, 127, 0 }, 0 },

	{ 148*kWhole, { kProgramChange, kProgramGuitar, 0, 0 }, 0 },
	{ 148*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{  297*kHalf, { kNoteOff, 70, 127, 0 }, 0 },
	{  297*kHalf, { kNoteOn,  69, 127, 0 }, 0 },
	{ 149*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 149*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 150*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 150*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 151*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 151*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 152*kWhole, { kNoteOff, 67, 127, 0 }, 0 },

	{ 152*kWhole, { kProgramChange, kProgramFlute, 0, 0 }, 0 },
	{ 152*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  305*kHalf, { kNoteOff, 72, 127, 0 }, 0 },
	{  305*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{ 153*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 153*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 154*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 154*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 155*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 155*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 156*kWhole, { kNoteOff, 69, 127, 0 }, 0 },

	{ 156*kWhole, { kProgramChange, kProgramGuitar, 0, 0 }, 0 },
	{ 156*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{  313*kHalf, { kNoteOff, 70, 127, 0 }, 0 },
	{  313*kHalf, { kNoteOn,  69, 127, 0 }, 0 },
	{ 157*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 157*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 158*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 158*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 159*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 159*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 160*kWhole, { kNoteOff, 67, 127, 0 }, 0 },

	{ 160*kWhole, { kProgramChange, kProgramViolin, 0, 0 }, 0 },
	{ 160*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{ 161*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{ 161*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 162*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 162*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 163*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 163*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 164*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 164*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 165*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 165*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 168*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
///////////////
	{ 168*kWhole, { kControlChange, kRhythm, kBeguine, 0 }, 0 },
	{ 168*kWhole, { kControlChange, kRhythmOn, 7, 0 }, 0 },
	{ 168*kWhole, { kProgramChange, kProgramFlute, 0, 0 }, 0 },

	{ 168*kWhole, { kNoteOn,  60, 127, 0 }, 0 },
	{ 169*kWhole, { kNoteOff, 60, 127, 0 }, 0 },
	{ 169*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 170*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 170*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 171*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 171*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 172*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 172*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 173*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 173*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  349*kHalf, { kNoteOff, 69, 127, 0 }, 0 },
	{  349*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{ 175*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 175*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{ 176*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{ 176*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{ 177*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 177*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 178*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 178*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 179*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 179*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 180*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 180*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 181*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 181*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 184*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 184*kWhole, { kNoteOn,  60, 127, 0 }, 0 },
	{ 185*kWhole, { kNoteOff, 60, 127, 0 }, 0 },
	{ 185*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 186*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 186*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 187*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 187*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 188*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 188*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 189*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 189*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{  381*kHalf, { kNoteOff, 69, 127, 0 }, 0 },
	{  381*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{ 191*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 191*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{ 192*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{ 192*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{ 193*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 193*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 194*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 194*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 195*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 195*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 196*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 196*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 197*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 197*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 200*kWhole, { kNoteOff, 65, 127, 0 }, 0 },

	{ 200*kWhole, { kProgramChange, kProgramGuitar, 0, 0 }, 0 },
	{ 200*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  401*kHalf, { kNoteOff, 72, 127, 0 }, 0 },
	{  401*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{ 201*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 201*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 202*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 202*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 203*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 203*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 204*kWhole, { kNoteOff, 69, 127, 0 }, 0 },

	{ 204*kWhole, { kProgramChange, kProgramPiano, 0, 0 }, 0 },
	{ 204*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{  409*kHalf, { kNoteOff, 70, 127, 0 }, 0 },
	{  409*kHalf, { kNoteOn,  69, 127, 0 }, 0 },
	{ 205*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 205*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 206*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 206*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 207*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 207*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 208*kWhole, { kNoteOff, 67, 127, 0 }, 0 },

	{ 208*kWhole, { kProgramChange, kProgramGuitar, 0, 0 }, 0 },
	{ 208*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{  417*kHalf, { kNoteOff, 72, 127, 0 }, 0 },
	{  417*kHalf, { kNoteOn,  70, 127, 0 }, 0 },
	{ 209*kWhole, { kNoteOff, 70, 127, 0 }, 0 },
	{ 209*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 210*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 210*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 211*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 211*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 212*kWhole, { kNoteOff, 69, 127, 0 }, 0 },

	{ 212*kWhole, { kProgramChange, kProgramPiano, 0, 0 }, 0 },
	{ 212*kWhole, { kNoteOn,  70, 127, 0 }, 0 },
	{  425*kHalf, { kNoteOff, 70, 127, 0 }, 0 },
	{  425*kHalf, { kNoteOn,  69, 127, 0 }, 0 },
	{ 213*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 213*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 214*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 214*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 215*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 215*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 216*kWhole, { kNoteOff, 67, 127, 0 }, 0 },

	{ 216*kWhole, { kProgramChange, kProgramFlute, 0, 0 }, 0 },
	{ 216*kWhole, { kNoteOn,  72, 127, 0 }, 0 },
	{ 217*kWhole, { kNoteOff, 72, 127, 0 }, 0 },
	{ 217*kWhole, { kNoteOn,  69, 127, 0 }, 0 },
	{ 218*kWhole, { kNoteOff, 69, 127, 0 }, 0 },
	{ 218*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 219*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
	{ 219*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 220*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 220*kWhole, { kNoteOn,  67, 127, 0 }, 0 },
	{ 221*kWhole, { kNoteOff, 67, 127, 0 }, 0 },
	{ 221*kWhole, { kNoteOn,  65, 127, 0 }, 0 },
	{ 894*kQuarter, { kControlChange, kRhythmOff, 0, 0 }, 0 }, // Stop rhythm.
	{ 224*kWhole, { kNoteOff, 65, 127, 0 }, 0 },
///////////////
	{ 224*kWhole, { kControlChange, kAllNotesOff, 0, 0 }, 0 }, // Stop notes.

	{         -1, { 0, 0, 0, 0 }, 0 }, // End of song.

};
